﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package {
	import flash.net.navigateToURL;
	import flash.net.URLVariables;
	import flash.net.URLRequest;
	import flash.display.StageScaleMode;
	import com.actionscriptfacile.ui.text.UITextField;
	import com.as3facile.DefaultButton;

	import flash.events.MouseEvent;
	
	import com.demonsters.debugger.MonsterDebugger;
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	
	[SWF(backgroundColor="0xF5FFFA")] // definit la couleur de fond du swf

	public class Main extends Sprite
	{		
		private var oTxtVotreMail : UITextField;
		private var oTxtInputName : UITextField;
		private var oTxtInputMail : UITextField;
		
		private var sInputNameInit:String = "Votre prenom... ";
		private var sInputMailInit:String = "Votre email... ";


		/**
		 * Constructeur.
		 * 
		 * Compiler avec le SDK Flex 4.6
		 * 
		 * -swf-version = 18 : pour l'API Flash Player 11.5
		 * -default-frame-rate 40 : nombre d'images par secondes
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * 
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, this, "Start aweber");
			
			stage.scaleMode = StageScaleMode.NO_SCALE;// permet de conserver la taille du swf
			
			this.buildUI();
		}


		/**
		 * Construit l'affichage de l'application.
		 * 
		 * 
		 */
		private function buildUI() : void
		{
			MonsterDebugger.trace(this, "buildUI");
			
			// ajout d'un texte informatif
			oTxtVotreMail = this.addText("Renseignez vos prénoms et email \npour recevoir gratuitement la Formation AS3 Facile !\n");
			oTxtVotreMail.x = 10;
			oTxtVotreMail.y = 5;
			this.addChild(oTxtVotreMail);
			
			
			// champ pour saisir le prénom			
			oTxtInputName = this.addTextInput(sInputNameInit);
			oTxtInputName.addEventListener(MouseEvent.CLICK, onClearInputName);
			oTxtInputName.x = oTxtVotreMail.x;
			oTxtInputName.y = oTxtVotreMail.y + oTxtVotreMail.maxHeight;
			this.addChild(oTxtInputName);
			
			// champ pour saisir l'adresse mail			
			oTxtInputMail = this.addTextInput(sInputMailInit);
			oTxtInputMail.addEventListener(MouseEvent.CLICK, onClearInputMail);
			oTxtInputMail.x = oTxtVotreMail.x;
			oTxtInputMail.y = oTxtInputName.y + oTxtInputName.height + 8;
			this.addChild(oTxtInputMail);
	
			stage.addEventListener(MouseEvent.CLICK, onClearInitInput);// si l'utilisateur clique sur l'application flash
			
			// Création des boutons
			var oBtnValid:DefaultButton = new DefaultButton();
			oBtnValid.getObject().label = "Valider";
			oBtnValid.getObject().x = oTxtInputMail.x + 231;
			oBtnValid.getObject().y = oTxtInputMail.y;
			oBtnValid.getObject().addEventListener ( MouseEvent.CLICK, onClickSubmit );// ajout d'un écouteur de l'évènement MouseEvent.CLICK
			this.addChild(oBtnValid);
		}


		/**
		 * Appel lors du clique sur le bouton.
		 * 
		 * Vérification adresse mail.
		 * Enregistrement dans la formation AS3 Facile.
		 * Envoie de l'évènement validationmail
		 * 
		 */
		private function onClickSubmit(event : MouseEvent) : void
		{
			MonsterDebugger.trace(this, "onClickSubmit : "+oTxtInputMail.text);
			
			// création de l'objet URLRequest pour l'appel du script aweber
			var url:String = "http://www.aweber.com/scripts/addlead.pl";
            var oRequest:URLRequest = new URLRequest(url);
			
			
			// renseigne les variables à transmettre à aweber
            var oVariables:URLVariables = new URLVariables();
            oVariables.listname = "pro_as3facile";// le nom de la liste aweber
            oVariables.meta_adtracking = "tuto aweber";// pour déterminer le nom du fomulaire (qui a récupéré l'email) dans aweber
            oVariables.meta_message = "1";// le message de départ dans les follow up aweber
            oVariables.meta_required = "email,name";// les champs obligatoires : ici nom et email
            oVariables.meta_forward_vars = "0";// si à 1, les champs demandés (nom, prénom, email...) pour l'ajout d'un email sont envoyés en GET dans la page de remerciement
            oVariables.name = oTxtInputName.text;// récupère le nom pour l'envoie à aweber
            oVariables.email = oTxtInputMail.text;// récupère l'email pour l'envoie à aweber
            oVariables.redirect = "http://bonus.actionscript-facile.com/merci-pour-votre-inscription";// la page de remerciement
           
			MonsterDebugger.trace(this, oVariables);
			
			oRequest.data = oVariables;
            navigateToURL(oRequest);// appel du script php, perl et envoie des informations à aweber
		}



		/**
		 * L'utilisateur a cliqué sur l'application flash.
		 * Remet les valeurs d'origines dans les champs textes.
		 * 
		 */
		private function onClearInitInput(event : MouseEvent) : void 
		{
			MonsterDebugger.trace(this, "onClearInitInput");

			// si le champ est vide
			if( oTxtInputName.text == "")
				 oTxtInputName.text = sInputNameInit;// remet sa valeur d'origine
				 
			// si le champ est vide
			if( oTxtInputMail.text == "")
				 oTxtInputMail.text = sInputMailInit;// remet sa valeur d'origine
		}


		/**
		 * Efface le champ saisi adresse mail.
		 * 
		 */
		private function onClearInputName(event : MouseEvent) : void
		{
			MonsterDebugger.trace(this, "onClearInputName");
			
			event.stopPropagation();// stop la diffusion de l'évènement

			// si le champ est égal à sa valeur d'origine
			if( oTxtInputName.text == sInputNameInit )
				oTxtInputName.text = "";// le champ texte est vide	
			
		}
		

		/**
		 * Efface le champ saisi adresse mail.
		 * 
		 */
		private function onClearInputMail(event : MouseEvent) : void
		{
			MonsterDebugger.trace(this, "onClearInputMail");
			
			event.stopPropagation();// stop la diffusion de l'évènement
			
			// si le champ est égal à sa valeur d'origine
			if( oTxtInputMail.text == sInputMailInit )
				oTxtInputMail.text = "";// le champ texte est vide

		}
		
		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.maxHeight = oTxtField.height = 50;
			oTxtField.changeFormat("bold", true);// changement de la taille de la police du texte
			oTxtField.changeFormat("size", 15);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x00C5DF);// changement de la couleur
			
			return oTxtField;	 
		}		


		/**
		 * Création d'un champ texte de type input.
		 * 
		 */
		private function addTextInput(sValue:String = "") : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.autoSizeNone();
			oTxtField.border = true;
			oTxtField.borderColor = 0x006f77;
			oTxtField.convertToInput();
			oTxtField.maxWidth = oTxtField.width = 226;
			oTxtField.maxHeight = oTxtField.height = 20;
			oTxtField.selectable = true;
			oTxtField.changeFormat("size", 14);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x999999);// changement de la couleur
			
			return oTxtField;	 
		}
		

	}
}
